From 42267b5ec3d339a013f873bcb3d12f942e734d2e Mon Sep 17 00:00:00 2001
From: Chenxiong Qi <cqi@redhat.com>
Date: Jul 04 2018 06:29:55 +0000
Subject: [PATCH 1/2] Modularize package metadata API


It is possible to access package metadata indepently.

    from pyrpkg.pkginfo import PackageMetadata
    from pyrpkg.pkgrepo import PackageRepository
    repo = PackageRepository('/path/to/repo')
    pkg = PackageMetadata(repo)
    print(pkg.nvr)
    print(pkg.spec)
    print(pkg.target)

Fixes #2

Signed-off-by: Chenxiong Qi <cqi@redhat.com>

---

diff --git a/pyrpkg/__init__.py b/pyrpkg/__init__.py
index c05b753..1448dbb 100644
--- a/pyrpkg/__init__.py
+++ b/pyrpkg/__init__.py
@@ -20,7 +20,6 @@ import io
 import koji
 import logging
 import os
-import posixpath
 import re
 import rpm
 import shutil
@@ -42,6 +41,7 @@ from pyrpkg.errors import HashtypeMixingError, rpkgError, rpkgAuthError, \
 from .gitignore import GitIgnore
 from pyrpkg.lookaside import CGILookasideCache
 from pyrpkg.sources import SourcesFile
+from pyrpkg.pkginfo import PackageMetadata
 from pyrpkg.pkgrepo import PackageRepository
 from pyrpkg.utils import cached_property, log_result, find_me
 
@@ -119,42 +119,12 @@ class Commands(object):
         self._anon_kojisession = None
         # The latest commit
         self._commit = None
-        # The disttag rpm value
-        self._disttag = None
-        # The distval rpm value
-        self._distval = None
-        # The distvar rpm value
-        self._distvar = None
-        # The rpm epoch of the cloned package
-        self._epoch = None
         # An authenticated buildsys session
         self._kojisession = None
         # A web url of the buildsys server
         self._kojiweburl = None
-        # The local arch to use in rpm building
-        self._localarch = None
-        # A property to load the mock config
-        self._mockconfig = None
-        # The name of the cloned repository
-        self._module_name = None
-        # The dist git namespace
-        self._ns = None
-        # The package name from spec file
-        self._package_name_spec = None
-        # The rpm name-version-release of the cloned package
-        self._nvr = None
-        # The rpm release of the cloned package
-        self._rel = None
         # The cloned repo object
         self._repo = None
-        # The rpm defines used when calling rpm
-        self._rpmdefines = None
-        # The specfile in the cloned package
-        self._spec = None
-        # The build target within the buildsystem
-        self._target = target
-        # The build target for containers within the buildsystem
-        self._container_build_target = target
         # The top url to our build server
         self._topurl = None
         # The user to use or discover
@@ -163,8 +133,6 @@ class Commands(object):
         self._password = None
         # The alternate Koji user to run commands as
         self._runas = None
-        # The rpm version of the cloned package
-        self._ver = None
         self.log = log
         # Default sources file output format type
         self.source_entry_type = 'old'
@@ -182,30 +150,6 @@ class Commands(object):
         # package name will be sent to lookaside CGI script as 'namespace/name'
         # instead of just name.
         self.lookaside_namespaced = lookaside_namespaced
-        # Deprecates self.module_name
-        self._repo_name = None
-
-        if distgit_namespaced:
-            try:
-                repo_name = self.repo.push_url
-            except rpkgError:
-                # Ignore error if cannot get remote push URL from this repo.
-                # That is we just skip has_namespace check when that error
-                # happens.
-                pass
-            else:
-                parts = urllib.parse.urlparse(repo_name)
-                parts = [p for p in parts.path.split('/') if p]
-                not_contain_namespace = len(parts) == 1
-                if not_contain_namespace:
-                    self.log.warning(
-                        'Your git configuration does not use a namespace.')
-                    self.log.warning(
-                        'Consider updating your git configuration by running:')
-                    self.log.warning(
-                        '  git remote set-url %s %s',
-                        self.repo.branch_remote,
-                        self._get_namespace_giturl(parts[0]))
 
     # Define properties here
     # Properties allow us to "lazy load" various attributes, which also means
@@ -408,38 +352,6 @@ class Commands(object):
             self.login_koji_session(koji_config, self._kojisession)
 
     @property
-    def disttag(self):
-        """This property ensures the disttag attribute"""
-
-        if not self._disttag:
-            self.load_rpmdefines()
-        return self._disttag
-
-    @property
-    def distval(self):
-        """This property ensures the distval attribute"""
-
-        if not self._distval:
-            self.load_rpmdefines()
-        return self._distval
-
-    @property
-    def distvar(self):
-        """This property ensures the distvar attribute"""
-
-        if not self._distvar:
-            self.load_rpmdefines()
-        return self._distvar
-
-    @property
-    def epoch(self):
-        """This property ensures the epoch attribute"""
-
-        if not self._epoch:
-            self.load_nameverrel()
-        return self._epoch
-
-    @property
     def kojiweburl(self):
         """This property ensures the kojiweburl attribute"""
 
@@ -448,208 +360,6 @@ class Commands(object):
         return self._kojiweburl
 
     @property
-    def localarch(self):
-        """This property ensures the localarch attribute"""
-
-        if not self._localarch:
-            self.load_localarch()
-        return(self._localarch)
-
-    def load_localarch(self):
-        """Get the local arch as defined by rpm"""
-
-        proc = subprocess.Popen(['rpm --eval %{_arch}'], shell=True,
-                                stdout=subprocess.PIPE,
-                                universal_newlines=True)
-        self._localarch = proc.communicate()[0].strip('\n')
-
-    @property
-    def mockconfig(self):
-        """This property ensures the mockconfig attribute"""
-
-        if not self._mockconfig:
-            self.load_mockconfig()
-        return self._mockconfig
-
-    @mockconfig.setter
-    def mockconfig(self, config):
-        self._mockconfig = config
-
-    def load_mockconfig(self):
-        """This sets the mockconfig attribute"""
-
-        self._mockconfig = '%s-%s' % (self.target, self.localarch)
-
-    @property
-    def repo_name(self):
-        """Property to get repository name"""
-        if not self._repo_name:
-            self.load_repo_name()
-        return self._repo_name
-
-    @repo_name.setter
-    def repo_name(self, name):
-        """Set repository name"""
-        self._repo_name = name
-
-    @property
-    def module_name(self):
-        """This property ensures the module attribute"""
-        self.log.warning('Property module_name is deprecated. Please use '
-                         'repo_name instead.')
-        return self.repo_name
-
-    @module_name.setter
-    def module_name(self, module_name):
-        self.log.warning('Property module_name is deprecated. Please use '
-                         'repo_name instead.')
-        self.repo_name = module_name
-
-    def load_module_name(self):
-        return self.load_repo_name()
-
-    def load_repo_name(self):
-        """Loads repository name"""
-
-        try:
-            if self.repo.push_url:
-                parts = urllib.parse.urlparse(self.repo.push_url)
-
-                # FIXME
-                # if self.distgit_namespaced:
-                #     self._module_name = "/".join(parts.path.split("/")[-2:])
-                repo_name = posixpath.basename(parts.path.strip('/'))
-
-                if repo_name.endswith('.git'):
-                    repo_name = repo_name[:-len('.git')]
-                self._repo_name = repo_name
-                return
-        except rpkgError:
-            self.log.warning('Failed to get repository name from Git url or pushurl')
-
-        self.load_nameverrel()
-        if self._package_name_spec:
-            self._repo_name = self._package_name_spec
-            return
-
-        raise rpkgError('Could not find current repository name.'
-                        ' Use --name and optional --namespace.')
-
-    @property
-    def ns(self):
-        """This property provides the namespace of the repository"""
-
-        if not self._ns:
-            self.load_ns()
-        return self._ns
-
-    @ns.setter
-    def ns(self, ns):
-        self._ns = ns
-
-    def load_ns(self):
-        """Loads the namespace"""
-
-        try:
-            if self.distgit_namespaced:
-                if self.repo.push_url:
-                    parts = urllib.parse.urlparse(self.repo.push_url)
-
-                    path_parts = [p for p in parts.path.split("/") if p]
-                    if len(path_parts) == 1:
-                        path_parts.insert(0, "rpms")
-                    ns = path_parts[-2]
-
-                    self._ns = ns
-            else:
-                self._ns = None
-                self.log.info("Could not find ns, distgit is not namespaced")
-        except rpkgError:
-            self.log.warning('Failed to get ns from Git url or pushurl')
-
-    @property
-    def ns_module_name(self):
-        self.log.warning('Property ns_module_name is deprecated. Please use '
-                         'ns_repo_name instead.')
-        return self.ns_repo_name
-
-    @property
-    def ns_repo_name(self):
-        if self.distgit_namespaced:
-            return '%s/%s' % (self.ns, self.repo_name)
-        else:
-            return self.repo_name
-
-    @property
-    def nvr(self):
-        """This property ensures the nvr attribute"""
-
-        if not self._nvr:
-            self.load_nvr()
-        return self._nvr
-
-    def load_nvr(self):
-        """This sets the nvr attribute"""
-
-        self._nvr = '%s-%s-%s' % (self.repo_name, self.ver, self.rel)
-
-    @property
-    def rel(self):
-        """This property ensures the rel attribute"""
-        if not self._rel:
-            self.load_nameverrel()
-        return(self._rel)
-
-    def load_nameverrel(self):
-        """Set the release of a package."""
-
-        cmd = ['rpm']
-        cmd.extend(self.rpmdefines)
-        # We make sure there is a space at the end of our query so that
-        # we can split it later.  When there are subpackages, we get a
-        # listing for each subpackage.  We only care about the first.
-        cmd.extend(['-q', '--qf', '"??%{NAME} %{EPOCH} %{VERSION} %{RELEASE}??"',
-                    '--specfile', '"%s"' % os.path.join(self.path, self.spec)])
-        joined_cmd = ' '.join(cmd)
-        try:
-            proc = subprocess.Popen(joined_cmd, shell=True,
-                                    universal_newlines=True,
-                                    stdout=subprocess.PIPE,
-                                    stderr=subprocess.PIPE)
-            output, err = proc.communicate()
-        except Exception as e:
-            if err:
-                self.log.debug('Errors occoured while running following command to get N-V-R-E:')
-                self.log.debug(joined_cmd)
-                self.log.error(err)
-            raise rpkgError('Could not query n-v-r of %s: %s'
-                            % (self.repo_name, e))
-        if err:
-            self.log.debug('Errors occoured while running following command to get N-V-R-E:')
-            self.log.debug(joined_cmd)
-            self.log.error(err)
-        if proc.returncode > 0:
-            raise rpkgError('Could not get n-v-r-e from %s'
-                            % os.path.join(self.path, self.spec))
-
-        # Get just the output, then split it by ??, grab the first and split
-        # again to get ver and rel
-        first_line_output = output.split('??')[1]
-        parts = first_line_output.split()
-        if len(parts) != 4:
-            raise rpkgError('Could not get n-v-r-e from %r'
-                            % first_line_output)
-        (self._package_name_spec,
-         self._epoch,
-         self._ver,
-         self._rel) = parts
-
-        # Most packages don't include a "Epoch: 0" line, in which case RPM
-        # returns '(none)'
-        if self._epoch == "(none)":
-            self._epoch = "0"
-
-    @property
     def repo(self):
         """This property ensures the repo attribute"""
 
@@ -670,94 +380,12 @@ class Commands(object):
             raise rpkgError('%s is not a valid repo' % self.path)
 
     @property
-    def rpmdefines(self):
-        """This property ensures the rpm defines"""
-
-        if not self._rpmdefines:
-            self.load_rpmdefines()
-        return(self._rpmdefines)
-
-    def load_rpmdefines(self):
-        """Populate rpmdefines based on current active branch"""
-
-        # This is another function ripe for subclassing
-
-        try:
-            # This regex should find the 'rhel-5' or 'rhel-6.2' parts of the
-            # branch name.  There should only be one of those, and all branches
-            # should end in one.
-            osver = re.search(r'rhel-\d.*$', self.repo.branch_merge).group()
-        except AttributeError:
-            raise rpkgError('Could not find the base OS ver from branch name'
-                            ' %s. Consider using --release option' %
-                            self.repo.branch_merge)
-        self._distvar, self._distval = osver.split('-')
-        self._distval = self._distval.replace('.', '_')
-        self._disttag = 'el%s' % self._distval
-        self._rpmdefines = ["--define '_sourcedir %s'" % self.path,
-                            "--define '_specdir %s'" % self.path,
-                            "--define '_builddir %s'" % self.path,
-                            "--define '_srcrpmdir %s'" % self.path,
-                            "--define '_rpmdir %s'" % self.path,
-                            "--define 'dist .%s'" % self._disttag,
-                            "--define '%s %s'" % (self._distvar,
-                                                  self._distval.split('_')[0]),
-                            # int and float this to remove the decimal
-                            "--define '%s 1'" % self._disttag]
-
-    @property
-    def spec(self):
-        """This property ensures the spec attribute"""
-
-        if not self._spec:
-            self.load_spec()
-        return self._spec
-
-    def load_spec(self):
-        """This sets the spec attribute"""
-
-        deadpackage = False
-
-        # Get a list of files in the path we're looking at
-        files = os.listdir(self.path)
-        # Search the files for the first one that ends with ".spec"
-        for f in files:
-            if f.endswith('.spec') and not f.startswith('.'):
-                self._spec = f
-                return
-            if f == 'dead.package':
-                deadpackage = True
-        if deadpackage:
-            raise rpkgError('No spec file found. This package is retired')
-        else:
-            raise rpkgError('No spec file found.')
-
-    @property
-    def target(self):
-        """This property ensures the target attribute"""
-
-        if not self._target:
-            self.load_target()
-        return self._target
-
-    def load_target(self):
-        """This creates the target attribute based on branch merge"""
-
-        # If a site has a different naming scheme, this would be where
-        # a site would override
-        self._target = '%s-candidate' % self.repo.branch_merge
-
-    @property
-    def container_build_target(self):
-        """This property ensures the target for container builds."""
-        if not self._container_build_target:
-            self.load_container_build_target()
-        return self._container_build_target
-
-    def load_container_build_target(self):
-        """This creates a target based on git branch and namespace."""
-        self._container_build_target = '%s-%s-candidate' % (
-            self.repo.branch_merge, self.ns)
+    def package(self):
+        if not hasattr(self, '_package'):
+            self._package = PackageMetadata(
+                self.repo,
+                distgit_namespaced=self.distgit_namespaced)
+        return self._package
 
     @property
     def topurl(self):
@@ -822,20 +450,9 @@ class Commands(object):
         self._runas = runas
 
     @property
-    def ver(self):
-        """This property ensures the ver attribute"""
-        if not self._ver:
-            self.load_nameverrel()
-        return(self._ver)
-
-    @property
     def mock_results_dir(self):
-        return os.path.join(self.path, "results_%s" % self.repo_name,
-                            self.ver, self.rel)
-
-    @property
-    def sources_filename(self):
-        return os.path.join(self.path, 'sources')
+        return os.path.join(self.path, "results_%s" % self.package.repo_name,
+                            self.package.ver, self.package.rel)
 
     @property
     def osbs_config_filename(self):
@@ -947,7 +564,7 @@ class Commands(object):
     def _get_build_arches_from_spec(self):
         """Given the path to an spec, retrieve the build arches"""
 
-        spec = os.path.join(self.path, self.spec)
+        spec = os.path.join(self.path, self.package.spec)
         try:
             hdr = rpm.spec(spec)
         except Exception:
@@ -1573,7 +1190,7 @@ class Commands(object):
         """
 
         # Create the outfile name based on arguments
-        outfile = '%s-%s-%s.patch' % (self.repo_name, self.ver, suffix)
+        outfile = '%s-%s-%s.patch' % (self.package.repo_name, self.package.ver, suffix)
 
         # If we want to rediff, the patch file has to already exist
         if rediff and not os.path.exists(os.path.join(self.path, outfile)):
@@ -1581,13 +1198,13 @@ class Commands(object):
                             os.path.join(self.path, outfile))
 
         # See if there is a source dir to diff in
-        if not os.path.isdir(os.path.join(self.path,
-                                          '%s-%s' % (self.repo_name,
-                                                     self.ver))):
+        expected_source_dir = os.path.join(
+            self.path, '%s-%s' % (self.package.repo_name, self.package.ver))
+        if not os.path.isdir(expected_source_dir):
             raise rpkgError('Expanded source dir not found!')
 
         # Setup the command
-        cmd = ['gendiff', '%s-%s' % (self.repo_name, self.ver),
+        cmd = ['gendiff', '%s-%s' % (self.package.repo_name, self.package.ver),
                '.%s' % suffix]
 
         # Try to run the command and capture the output
@@ -1658,7 +1275,7 @@ class Commands(object):
                            in glob.glob(file_pattern)]
 
         git_tree = self.repo.repo.head.commit.tree
-        sources_file = SourcesFile(self.sources_filename,
+        sources_file = SourcesFile(self.package.sources_filename,
                                    self.source_entry_type)
 
         patches_not_tracked = [
@@ -1694,7 +1311,7 @@ class Commands(object):
     def sources(self, outdir=None):
         """Download source files"""
 
-        if not os.path.exists(self.sources_filename):
+        if not os.path.exists(self.package.sources_filename):
             self.log.info("sources file doesn't exist. Source files download skipped.")
             return
 
@@ -1702,7 +1319,7 @@ class Commands(object):
         if not outdir:
             outdir = self.path
 
-        sourcesf = SourcesFile(self.sources_filename, self.source_entry_type)
+        sourcesf = SourcesFile(self.package.sources_filename, self.source_entry_type)
 
         args = dict()
         if self.lookaside_request_params:
@@ -1716,11 +1333,39 @@ class Commands(object):
 
         for entry in sourcesf.entries:
             outfile = os.path.join(outdir, entry.file)
+            if self.lookaside_namespaced:
+                repo_name = self.package.ns_repo_name
+            else:
+                repo_name = self.package.repo_name
             self.lookasidecache.download(
-                self.ns_repo_name if self.lookaside_namespaced else self.repo_name,
-                entry.file, entry.hash, outfile,
+                repo_name, entry.file, entry.hash, outfile,
                 hashtype=entry.hashtype, **args)
 
+    def check_repo(self, has_namespace=True, **criteria):
+        self.repo.check(**criteria)
+
+        if has_namespace:
+            try:
+                repo_name = self.repo.push_url
+            except rpkgError:
+                # Ignore error if cannot get remote push URL from this repo.
+                # That is we just skip has_namespace check when that error
+                # happens.
+                pass
+            else:
+                parts = urllib.parse.urlparse(repo_name)
+                parts = [p for p in parts.path.split('/') if p]
+                not_contain_namespace = len(parts) == 1
+                if not_contain_namespace:
+                    self.log.warning(
+                        'Your git configuration does not use a namespace.')
+                    self.log.warning(
+                        'Consider updating your git configuration by running:')
+                    self.log.warning(
+                        '  git remote set-url %s %s',
+                        self.repo.branch_remote,
+                        self._get_namespace_giturl(parts[0]))
+
     def switch_branch(self, branch, fetch=True):
         """Switch the working branch
 
@@ -1734,7 +1379,7 @@ class Commands(object):
         # the first remote it finds.  When multiple remotes are in play
         # this needs to get smarter
 
-        self.repo.check(all_pushed=False)
+        self.check_repo(all_pushed=False)
 
         # Get our list of branches
         self.log.debug('Listing refs')
@@ -1793,7 +1438,8 @@ class Commands(object):
         :rtype: str
         """
         return '{0}#{1}'.format(
-            self._get_namespace_anongiturl(repo_name or self.ns_repo_name),
+            self._get_namespace_anongiturl(
+                repo_name or self.package.ns_repo_name),
             commit_hash or self.repo.commit_hash)
 
     def build(self, skip_tag=False, scratch=False, background=False,
@@ -1835,7 +1481,7 @@ class Commands(object):
             # Check to see if the tree is dirty and if all local commits
             # are pushed
             try:
-                self.repo.check()
+                self.check_repo()
             except rpkgError as e:
                 msg = '{0}\n{1}'.format(
                     str(e),
@@ -1843,9 +1489,9 @@ class Commands(object):
                 raise rpkgError(msg)
             url = self.construct_build_url()
         # Check to see if the target is valid
-        build_target = self.kojisession.getBuildTarget(self.target)
+        build_target = self.kojisession.getBuildTarget(self.package.target)
         if not build_target:
-            raise rpkgError('Unknown build target: %s' % self.target)
+            raise rpkgError('Unknown build target: %s' % self.package.target)
         # see if the dest tag is locked
         dest_tag = self.kojisession.getTag(build_target['dest_tag_name'])
         if not dest_tag:
@@ -1885,14 +1531,14 @@ class Commands(object):
             cmd.append('--arch-override=%s' % ','.join(arches))
             opts['arch_override'] = ' '.join(arches)
 
-        cmd.append(self.target)
+        cmd.append(self.package.target)
 
         if url.endswith('.src.rpm'):
             srpm = os.path.basename(url)
             build_reference = srpm
         else:
             try:
-                build_reference = self.nvr
+                build_reference = self.package.nvr
             except rpkgError as error:
                 self.log.warning(error)
                 if nvr_check:
@@ -1905,18 +1551,18 @@ class Commands(object):
                                   ' care that I am not able to construct NVR.'
                                   '  I will refer this build by package name'
                                   ' in following messages.')
-                    build_reference = self.repo_name
+                    build_reference = self.package.repo_name
 
         # see if this build has been done.  Does not check builds within
         # a chain
         if nvr_check and not scratch and not url.endswith('.src.rpm'):
-            build = self.kojisession.getBuild(self.nvr)
+            build = self.kojisession.getBuild(self.package.nvr)
             if build:
                 if build['state'] == 1:
                     raise rpkgError('Package %s has already been built\n'
                                     'Note: You can skip this check with'
                                     ' --skip-nvr-check. See help for more'
-                                    ' info.' % self.nvr)
+                                    ' info.' % self.package.nvr)
         # Now submit the task and get the task_id to return
         # Handle the chain build version
         if chain:
@@ -1932,19 +1578,21 @@ class Commands(object):
             # This next list comp is ugly, but it's how we properly get a :
             # put in between each build set
             cmd.extend(' : '.join([' '.join(build_sets) for build_sets in chain]).split())
-            self.log.info('Chain building %s + %s for %s', build_reference, chain[:-1], self.target)
+            self.log.info('Chain building %s + %s for %s',
+                          build_reference, chain[:-1], self.package.target)
             self.log.debug('Building chain %s for %s with options %s and a priority of %s',
-                           chain, self.target, opts, priority)
+                           chain, self.package.target, opts, priority)
             self.log.debug(' '.join(cmd))
-            task_id = self.kojisession.chainBuild(chain, self.target, opts, priority=priority)
+            task_id = self.kojisession.chainBuild(
+                chain, self.package.target, opts, priority=priority)
         # Now handle the normal build
         else:
             cmd.append(url)
-            self.log.info('Building %s for %s', build_reference, self.target)
+            self.log.info('Building %s for %s', build_reference, self.package.target)
             self.log.debug('Building %s for %s with options %s and a priority of %s',
-                           url, self.target, opts, priority)
+                           url, self.package.target, opts, priority)
             self.log.debug(' '.join(cmd))
-            task_id = self.kojisession.build(url, self.target, opts, priority=priority)
+            task_id = self.kojisession.build(url, self.package.target, opts, priority=priority)
         self.log.info('Created task: %s', task_id)
         self.log.info('Task info: %s/taskinfo?taskID=%s', self.kojiweburl, task_id)
         return task_id
@@ -1952,9 +1600,13 @@ class Commands(object):
     def clog(self, raw=False):
         """Write the latest spec changelog entry to a clog file"""
 
-        spec_file = os.path.join(self.path, self.spec)
-        cmd = ['rpm'] + self.rpmdefines + ['-q', '--qf', '"%{CHANGELOGTEXT}\n"',
-                                           '--specfile', '"%s"' % spec_file]
+        spec_file = os.path.join(self.path, self.package.spec)
+        cmd = (
+            ['rpm'] +
+            self.package.rpmdefines +
+            ['-q', '--qf', '"%{CHANGELOGTEXT}\n"', '--specfile',
+             '"%s"' % spec_file]
+        )
         proc = subprocess.Popen(' '.join(cmd), shell=True,
                                 stdout=subprocess.PIPE, stderr=subprocess.PIPE,
                                 universal_newlines=True)
@@ -1994,7 +1646,7 @@ class Commands(object):
 
         # setup the rpm command
         cmd = ['rpmbuild']
-        cmd.extend(self.rpmdefines)
+        cmd.extend(self.package.rpmdefines)
         if builddir:
             # Tack on a new builddir to the end of the defines
             cmd.append("--define '_builddir %s'" % os.path.abspath(builddir))
@@ -2006,13 +1658,13 @@ class Commands(object):
             cmd.append('--nocheck')
         if self.quiet:
             cmd.append('--quiet')
-        cmd.extend(['-bc', os.path.join(self.path, self.spec)])
+        cmd.extend(['-bc', os.path.join(self.path, self.package.spec)])
         # Run the command
         self._run_command(cmd, shell=True)
 
     def giturl(self):
         """Return the git url that would be used for building"""
-        self.repo.check(is_dirty=False, all_pushed=False)
+        self.check_repo(is_dirty=False, all_pushed=False)
         return self.construct_build_url()
 
     def koji_upload(self, file, path, callback=None):
@@ -2047,7 +1699,7 @@ class Commands(object):
 
         # setup the rpm command
         cmd = ['rpmbuild']
-        cmd.extend(self.rpmdefines)
+        cmd.extend(self.package.rpmdefines)
         if builddir:
             # Tack on a new builddir to the end of the defines
             cmd.append("--define '_builddir %s'" % os.path.abspath(builddir))
@@ -2059,7 +1711,7 @@ class Commands(object):
             cmd.append('--nocheck')
         if self.quiet:
             cmd.append('--quiet')
-        cmd.extend(['-bi', os.path.join(self.path, self.spec)])
+        cmd.extend(['-bi', os.path.join(self.path, self.package.spec)])
         # Run the command
         self._run_command(cmd, shell=True)
         return
@@ -2073,7 +1725,8 @@ class Commands(object):
         """
 
         # Check for srpm
-        srpm = "%s-%s-%s.src.rpm" % (self.repo_name, self.ver, self.rel)
+        srpm = "%s-%s-%s.src.rpm" % (
+            self.package.repo_name, self.package.ver, self.package.rel)
         if not os.path.exists(os.path.join(self.path, srpm)):
             log.warning('No srpm found')
 
@@ -2088,7 +1741,7 @@ class Commands(object):
         if not rpms:
             log.warning('No rpm found')
         cmd = ['rpmlint']
-        default_rpmlintconf = '{0}.rpmlintrc'.format(self.repo_name)
+        default_rpmlintconf = '{0}.rpmlintrc'.format(self.package.repo_name)
         if info:
             cmd.extend(['-i'])
         if rpmlintconf:
@@ -2100,7 +1753,7 @@ class Commands(object):
             self.log.warning('.rpmlint file usage as default rpmlint configuration is deprecated '
                              'and will be removed in future version. '
                              'Use {0} instead'.format(default_rpmlintconf))
-        cmd.append(os.path.join(self.path, self.spec))
+        cmd.append(os.path.join(self.path, self.package.spec))
         if os.path.exists(os.path.join(self.path, srpm)):
             cmd.append(os.path.join(self.path, srpm))
         cmd.extend(sorted(rpms))
@@ -2128,7 +1781,7 @@ class Commands(object):
         # Get the sources
         # build up the rpm command
         cmd = ['rpmbuild']
-        cmd.extend(self.rpmdefines + localargs)
+        cmd.extend(self.package.rpmdefines + localargs)
         if builddir:
             # Tack on a new builddir to the end of the defines
             cmd.append("--define '_builddir %s'" % os.path.abspath(builddir))
@@ -2146,8 +1799,8 @@ class Commands(object):
             cmd.extend(['--target', arch])
         if self.quiet:
             cmd.append('--quiet')
-        cmd.extend(['-ba', os.path.join(self.path, self.spec)])
-        logfile = '.build-%s-%s.log' % (self.ver, self.rel)
+        cmd.extend(['-ba', os.path.join(self.path, self.package.spec)])
+        logfile = '.build-%s-%s.log' % (self.package.ver, self.package.rel)
 
         cmd = '%s | tee %s' % (' '.join(cmd), logfile)
         try:
@@ -2174,9 +1827,9 @@ class Commands(object):
 
         # Figure out some things about ourself.
         if not target:
-            target = self.target
+            target = self.package.target
         if not arch:
-            arch = self.localarch
+            arch = self.package.localarch
 
         # Figure out if we have a valid build target
         build_target = self.anon_kojisession.getBuildTarget(target)
